"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const PURE_ANNOTATION = "#__PURE__";
const isPureAnnotated = (comments) => {
    if (typeof comments === "undefined") {
        return false;
    }
    if (comments && comments.length > 0) {
        return comments[comments.length - 1].value === PURE_ANNOTATION;
    }
    return false;
};
const createComponentBlock = (value) => ({
    type: "CommentBlock",
    value,
});
exports.default = () => ({
    name: "pure-calls-annotation",
    inherits: require("@babel/plugin-syntax-dynamic-import").default,
    visitor: {
        CallExpression: {
            enter(nodePath) {
                if (nodePath.parentPath.isVariableDeclarator() ||
                    nodePath.parentPath.isAssignmentExpression() ||
                    (nodePath.parentPath.isCallExpression() &&
                        (nodePath.parentPath.get("arguments") ||
                            []).indexOf(nodePath) > -1)) {
                    if (!isPureAnnotated(nodePath.node.leadingComments)) {
                        const pureAnnotation = createComponentBlock(PURE_ANNOTATION);
                        nodePath.replaceWith(Object.assign({}, nodePath.node, { leadingComments: nodePath.node.leadingComments
                                ? nodePath.node.leadingComments.concat(pureAnnotation)
                                : [pureAnnotation] }));
                    }
                }
            },
        },
    },
});
//# sourceMappingURL=index.js.map